controllers/SiteController.php
<?php

namespace app\controllers;

use app\models\Alumno;
use app\models\Alumnos;
use yii\data\ActiveDataProvider;
use yii\data\ArrayDataProvider;
use yii\filters\AccessControl;
use yii\filters\VerbFilter;
use yii\web\Controller;
use const YII_ENV_TEST;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }
    
    /**
     * accion que me permite mostrar un array enumerado de
     * arrays asociativos utilizando Html::ul o Html::ol o foreach
     * 
     */
    public function actionEjercicio1() {
        
        // array enumerado
        // de arrays asociativos
        $alumnos=[
            [
                "id" => 1,
                "nombre" => "Eva",
                "curso" => "Excel"
            ],
            [
                "id" => 2,
                "nombre" => "Luis",
                "curso" => "Access"
            ],
            [
                "id" => 3,
                "nombre" => "Susana",
                "curso" => "Excel"
            ],
        ];
        
                
        // para mostrar el array asociativo lo mando a la vista
        // ejercicio1
        return $this->render("ejercicio1",[
            "datos" => $alumnos,
        ]);
        
    }
    
    // mostrar el contenido de un array enumerado
    // utilizando Html::ul o Html::ol o foreach
    
    public function actionEjercicio2() {
        $numeros=[
            1,"23",3,4,5,6,7,8
        ];
        
        return $this->render("ejercicio2",[
            "datos" => $numeros
        ]);
    }
    
    /*
     * esta accion me permite mostrar el contenido
     * de dos arrays enumerados de arrays asociativos
     * utilizando en la vista Html::ul, Html::ol , foreach
     */
    
    public function actionEjercicio3(){
        $aprobados=[
           [
                "id" => 1,
                "nombre" => "Eva",
                "curso" => "Excel"
            ],
            [
                "id" => 2,
                "nombre" => "Luis",
                "curso" => "Access"
            ],
        ];
        
        $suspensos=[
            [
                "id" => 3,
                "nombre" => "Susana",
                "curso" => "Excel"
            ],   
        ];
        
        return $this->render("ejercicio3",[
            "aprobados" => $aprobados,
            "suspensos" => $suspensos
        ]);
    }
    
    /**
     * Quiero mostrar el contenido de un array enumerado
     * de arrays asociativos pero utilizando en la vista
     * el widget GRIDVIEW
     */
    
    public function actionEjercicio4(){
      
              
        // array de arrays asociativos
        $alumnos=[
            [
                "id" => 1,
                "nombre" => "Eva",
                "curso" => "Excel",
            ],
            [
                "id" => 2,
                "nombre" => "Luis",
                "curso" => "Access"
            ],
            [
                "id" => 3,
                "nombre" => "Susana",
                "curso" => "Excel"
            ],
        ];
        
        // convierto el array en un proveedor de datos
        $dataProvider=new ArrayDataProvider([
            "allModels" => $alumnos
        ]);
        
        // le mando el proveedor de datos a la vista
        // y la vista utilizando un gridview me muestra todos los registros
        return $this->render("ejercicio4",[
           "dataProvider" => $dataProvider 
        ]);
    }
    
    // tengo un array de modelos
    // que quiero visualizar utilizando un GRIDVIEW
    
    public function actionEjercicio5(){
        
        // array modelos
        $alumnos=[
            new Alumnos([
                "id" => 1,
                "nombre" => "Eva",
                "curso" => "Excel"
            ]),
            new Alumnos([
                "id" => 2,
                "nombre" => "Luis",
                "curso" => "Access"
            ]),
            new Alumnos([
                "id" => 3,
                "nombre" => "Susana",
                "curso" => "Excel"  
            ]),
        ];
       
        
        //aqui muestro los alumnos con un gridview
        $dataProvider=new ArrayDataProvider([
            "allModels" => $alumnos
        ]);
        
        return $this->render("ejercicio4",[
           "dataProvider" => $dataProvider 
        ]);
        
    }
    
    // TENGO UN ARRAY DE MODELOS Y QUIERO VISULIZARLO CON UN LISTVIEW
    
    public function actionEjercicio6(){
        
        // array modelos
        $alumnos=[
            new Alumnos([
                "id" => 1,
                "nombre" => "Eva",
                "curso" => "Excel"
            ]),
            new Alumnos([
                "id" => 2,
                "nombre" => "Luis",
                "curso" => "Access"
            ]),
            new Alumnos([
                "id" => 3,
                "nombre" => "Susana",
                "curso" => "Excel"  
            ]),
        ];
                
        // CREO UN DATAPROVIDER DESDE  EL ARRAY
        $dataProvider=new ArrayDataProvider([
            "allModels" => $alumnos
        ]);
        
        // MANDO EL DATAPROVIDER A LA VISTA
        return $this->render("ejercicio6",[
           "dataProvider" => $dataProvider 
        ]);
        
    }
    
    
    public function actionEjercicio7(){
        //quiero consultar la tabla Alumno
        
        // consulta sin ejecutar
        // me devuelve un ActiveQuery
        $query=Alumno::find(); 
        
        $dataProvider=new ActiveDataProvider([
            "query" => $query
        ]);
        
        // mandarle el resultado de la query
        // a una vista
        
        return $this->render("ejercicio7",[
            "dataProvider" => $dataProvider
        ]);
    }
    
     public function actionEjercicio8(){
        //quiero consultar la tabla Alumno
        
        // consulta sin ejecutar
        // me devuelve un array de ActiveRecord (modelos)
        $resultado=Alumno::find()->all(); 
        
        $dataProvider=new ArrayDataProvider([
            "allModels" => $resultado
        ]);       
        
        
        // mandarle el resultado de la query
        // a una vista
        
        return $this->render("ejercicio7",[
            "dataProvider" => $dataProvider
        ]);
    }
    
    
    public function actionEjercicio9(){
        
        // creo un modelo Alumnos
        $model=new Alumnos();
        $model->id=10;
        $model->nombre="Federico";
        $model->curso="Word";
        
        // mando el modelo a la vista
        // y en la vista lo visualizo con
        // detailView
        return $this->render("ejercicio9",[
            "model" => $model
        ]);
        
    }
    
    public function actionEjercicio10(){
        // creo un registro
        // con un array asociativo
        $dato=[
            "id" => 10,
            "nombre" => "Federico",
            "curso" => "Word"
        ];
        
        // mando el array asociativo
        // a una vista que tiene el detailView
        return $this->render("ejercicio9",[
            "model" => $dato
        ]);
        
    }
    
    public function actionEjercicio11(){
        // creando una clase basado en ActiveRecord
        $model=new Alumno();
        $model->id=10;
        $model->nombre="Federico";
        $model->curso="Word";
        
        $model->save(); // inserto o actualizo el registro en la tabla
        
        // mando el modelo a la vista
        // y en la vista lo visualizo con
        // detailView
        return $this->render("ejercicio9",[
            "model" => $model
        ]);
        
    }
    
    public function actionEjercicio12($id=1){
        // creando una clase basado en ActiveRecord
        // ejecutando la consulta de sql
        // select * from alumno where id=1
        $model=Alumno::findOne($id);
               
                
        // mando el modelo a la vista
        // y en la vista lo visualizo con
        // detailView
        return $this->render("ejercicio9",[
            "model" => $model
        ]);
        
    }
    
    public function actionEjercicio13(){
        // array con el contenido del directorio actual
        $contenido= scandir(".");
             
        
        $dataProvider=new ArrayDataProvider([
           "allModels" => $contenido 
        ]);
        
        return $this->render("ejercicio13",[
            "contenido" => $contenido,
            "dataProvider" => $dataProvider
        ]);
    }
    
}

views/layouts/main.php
<?php

/* @var $this \yii\web\View */
/* @var $content string */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap4\Breadcrumbs;
use yii\bootstrap4\Html;
use yii\bootstrap4\Nav;
use yii\bootstrap4\NavBar;

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <?php $this->registerCsrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body class="d-flex flex-column h-100">
<?php $this->beginBody() ?>

<header>
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'options' => [
            'class' => 'navbar navbar-expand-md navbar-dark bg-dark fixed-top',
        ],
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav'],
        'items' => [
            ['label' => 'Home', 'url' => ['/site/index']],
            ['label' => 'Array', 'items' => [
                ['label' => 'Ejercicio1', 'url' => ['/site/ejercicio1']],
                ['label' => 'Ejercicio2', 'url' => ['/site/ejercicio2']],
                ['label' => 'Ejercicio3', 'url' => ['/site/ejercicio3']],
                ['label' => 'Ejercicio4', 'url' => ['/site/ejercicio4']],
                ['label' => 'Ejercicio5', 'url' => ['/site/ejercicio5']],
                ['label' => 'Ejercicio6', 'url' => ['/site/ejercicio6']],
            ]],
            ['label' => 'Modelos Active Record' , 'items' => [
                ['label' => 'Ejercicio7', 'url' => ['/site/ejercicio7']],
                ['label' => 'Ejercicio8', 'url' => ['/site/ejercicio8']],
            ]],
            ['label' => 'Mostrar un registro' , 'items' => [
                ['label' => 'Ejercicio9', 'url' => ['/site/ejercicio9']],
                ['label' => 'Ejercicio10', 'url' => ['/site/ejercicio10']],
                ['label' => 'Ejercicio11', 'url' => ['/site/ejercicio11']],
                ['label' => 'Ejercicio12', 'url' => ['/site/ejercicio12']],
            ]],
           
            
        ],
    ]);
    NavBar::end();
    ?>
</header>

<main role="main" class="flex-shrink-0">
    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</main>

<footer class="footer mt-auto py-3 text-muted">
    <div class="container">
        <p class="float-left">&copy; My Company <?= date('Y') ?></p>
        <p class="float-right"><?= Yii::powered() ?></p>
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>